#!/usr/bin/python

#zkmRequest module

import string
import urllib

from zkmUrl import constructAbsoluteUrl, getUrlBaseFromFullUrl
from zkmTrace import writeTrace, writeError

class ZkmRequest:
    #For manipulating all info. related to the http(s) request, including the url information.
    #The 'zkmUrl' must always be converted to start with http:// or https://
    #
    def __init__(self, request, authenticatedUser):
        #request is http request from Zope
        self.request = request

        userName = `authenticatedUser`
        self.userName = string.replace(userName, " ", "_")

        self.form = self.request.form

        if not self.form.keys():
            self.form = self.loadForm(self.request.environ["QUERY_STRING"])

        self.zkmUrl = self.form["zkmUrl"]
        del self.form["zkmUrl"]

        if self.form.has_key("zkmGc"):
            self.graphicsCaching = 1
            del self.form["zkmGc"]
        else:
            self.graphicsCaching = 0

        if self.form.has_key("zkmSubmit"):
            del self.form["zkmSubmit"]

        self.queryString = ""
        if self.form.keys():
            self.queryString = "?" + urllib.urlencode(self.form)

        self.urlToOpen = self.zkmUrl + self.queryString

        httpHost = self.request["HTTP_HOST"]
        self.serverName = string.split(httpHost, ":")[0]
        self.serverPort = self.request["SERVER_PORT"]

        return

    def loadForm(self, s):
        args = string.split(s, "&")

        form = {}

        for a in args:
            argVal = string.split(a, "=")

            if argVal[1]:
                form[argVal[0]] = argVal[1]
            else:
                form[argVal[0]] = ""

        return form

    def writeTrace(self):
        s = "\n"
        for k in self.__dict__.keys():
            s = s + `k` + "=" + `self.__dict__[k]` + "\n"
        s = s + "\n"
        for k in self.request.__dict__.keys():
            s = s + `k` + "=" + `self.request.__dict__[k]` + "\n"
        s = s + "\n"
        for k in self.request.environ.keys():
            s = s + `k` + "=" + `self.request.environ[k]` + "\n"
        writeTrace(s)
        return
