#!/usr/bin/python

#zkmSocket module

from zkmTrace import writeTrace, writeError

import socket

class ZkmSocket:
    def __init__(self, command=None, serverName=None, port=None):
        self.command = command
        self.serverName = serverName
        self.port = port
        return

    def tryConnect(self):
        try:
            self.clientsock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        except:
            writeError("ZkmSocket tryConnect socket creation exception: " + `data`)
            return 0
        else:
            for i in range(0, 3):
                try:
                    self.clientsock.connect(self.serverName, self.port)

                except Exception, data:
                    result = 0
                else:
                    result = 1
                    break

        if result == 0:
            writeError("ZkmSocket tryConnect socket connect exception: " + `data`)

        return result

    def sendCommandNoResponse(self):
        try:
            if self.tryConnect():
                self.clientsock.send(self.command.serialize())
                self.clientsock.close()
            else:
                return 0

        except Exception, data:
            writeError("ZkmSocket sendCommandNoResponse exception: " + `data`)

            cleanupSocket(self.clientsock)

            return 0
        else:
            return 1

    def sendCommandGetResponse(self):
        try:
            if self.tryConnect():
                self.clientsock.send(self.command.serialize())
                response = self.clientsock.recv(204800)
                self.clientsock.close()
            else:
                return (0, None)

        except Exception, data:
            writeError("ZkmSocket sendCommandGetResponse() exception: " + `data`, command=self.command)

            cleanupSocket(self.clientsock)

            return (0, None)

        else:
            return (1, response)

def cleanupSocket(sock):
    try:
        sock.close()
    except:
        pass
    return
