#!/usr/bin/python

#zkmTrace module

import sys
import traceback
import time

trace = 1   #Controls writing trace info. to debug log; 1=write; 0=don't write

debugFileName = "c:\\debug.txt" #Default file name; overridden using filePath function

def filePath(s):
    global debugFileName
    debugFileName = s
    return

def writeTrace(s, command=None):
    if trace:
        debugFile = open(debugFileName, "a+")
        debugFile.write(time.ctime(time.time()) + "\t" + s + "\n")
        if command:
             debugFile.write("\n" + command.serialize() + "\n")
        debugFile.write(("-" * 80) + "\n\n")
        debugFile.close()
    return

def writeError(s, command=None):
    debugFile = open(debugFileName, "a+")
    debugFile.write(time.ctime(time.time()) + "\t" + s + "\n")
    if command:
         debugFile.write("\n" + command.serialize() + "\n")
    debugFile.write(("-" * 80) + "\n\n")
    debugFile.close()
    return

def showError(s):
    print s
    writeError(s)
    return

def formattedTracebackString(limit):
    type, value, tb = sys.exc_info()
    list = traceback.format_exception(type, value, tb, limit)
    s = ""

    for item in list:
        s = s + item + "\n"

    return s

def writeTracebackAsString(limit):
    s = formattedTracebackString(limit)
    writeError(s)
    return s

